#include <netdb.h>
#include <sys/poll.h>
#include <sys/socket.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <unistd.h>
#include <netinet/in.h>
#include <time.h>

int main(int argc,char* argv[]) {
  struct pollfd inout[2];
  struct hostent* r;
  char buf[1024];
  char* cur=buf;
  int len,inbuf,fertig;

  time_t last,now;	/* timeout handling */
  time_t glimit;
  int llimit;

  struct sockaddr_in sa;
  int sock=socket(PF_INET,SOCK_STREAM,IPPROTO_TCP);
  if (argc<3) {
    printf("usage: %s [-A global-timeout] [-a local-timeout] hostname port\n",argv[0]);
    return 1;
  }
  last=now=time(0);
  glimit=(time_t)-1;
  llimit=10000;

  if (argv[1][0]=='-' && argv[1][1]=='A') {
    int a=0;
    if (argv[1][2]) {
      a=atoi(argv[1]+2);
      argv++;
    } else {
      a=atoi(argv[2]);
      argv+=2;
    }
    if (a>0) {
//      alarm(a);
      glimit=now+a;
    }
  }

  if (argv[1][0]=='-' && argv[1][1]=='a') {
    int a=0;
    if (argv[1][2]) {
      a=atoi(argv[1]+2);
      argv++;
    } else {
      a=atoi(argv[2]);
      argv+=2;
    }
    if (a>0) llimit=a;
  }

  if (!(r=gethostbyname(argv[1]))) {
    printf("dns error\n");
    return 2;
  }
  if (sock==-1) { perror("socket"); return 1; }
  sa.sin_family=PF_INET;
  sa.sin_addr=(*((struct in_addr*)(r->h_addr_list)[0]));
  if (isdigit(argv[2][0]))
    sa.sin_port=htons(atoi(argv[2]));
  else {
    struct servent* s=getservbyname(argv[2],"tcp");
    if (!s) {
      fprintf(stderr,"Ungltiger Dienst/Port \"%s\"!\n",argv[2]);
      exit(1);
    }
    sa.sin_port=s->s_port;
  }
  if (connect(sock,(struct sockaddr*)&sa,sizeof sa)) {
    perror("connect"); return 1;
  }
  /* Verbindung steht */
  inbuf=fertig=0;
  inout[0].fd=0; inout[0].events=POLLIN;
  inout[1].fd=sock; inout[1].events=POLLIN;
  for (;;) {
    if (inbuf) {
      inout[0].fd=sock; inout[0].events=POLLOUT;
    } else {
      inout[0].fd=0; inout[0].events=POLLIN;
    }

    now=time(0);
    if (now>glimit) { fprintf(stderr,"global timeout!\n"); exit(0); }
    if (last+llimit<now) {
      fprintf(stderr,"local timeout: %lx vs %lx!\n",last+llimit,now);
      exit(0);
    }

    if (poll(inout+fertig,2-fertig,1000)<0) {
      perror("poll");
      exit(1);
    }
    if (inout[0].revents) {
      last=now;
      /* Daten auf stdin */
      if (inbuf) {
	int tmp=write(sock,cur,inbuf);
	if (tmp<0) {
	  perror("write");
	  exit(0);
	}
	cur+=tmp; inbuf-=tmp;
      } else {
	len=read(0,buf,1024);
	if (len<=0) {
	  shutdown(sock,SHUT_WR);
	  fertig=1; inout[0].revents=0;
	  continue;
	}
	cur=buf; inbuf=len;
      }
    } else if (inout[1].revents) {
      last=now;
      len=read(sock,buf,1024);
      if (len<=0) break;
      write(1,buf,len);
    }
  }
  puts("Verbindung geschlossen.");
  return 0;
}
